// ym2608test.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"


void write(unsigned char addr,unsigned char data);
void write2(unsigned char addr,unsigned char data);

void pin_debug();

void adpcm_init(unsigned short sampling_rate,unsigned char total_level,unsigned char pan);
void adpcm_play(unsigned char idx);
void adpcm_load(unsigned char idx,const char *filename);
void _write(unsigned char addr,unsigned char data);
void _write2(unsigned char addr,unsigned char data);
void _reset();


//
//	YM2608쓮pfvO
//
//
//
//
int main(int argc, char* argv[])
{
	pin_debug();

	return 0;
}


unsigned long get_numeric(const char *p)
{
	unsigned long x = 0;

	do
	{
		if (*p >= '0' && *p <= '9')	break;
		p++;
	}while(*p);

	if (*p == '\0')	return 0;

	do
	{
		if (*p >= '0' && *p <= '9')
		{
			x = x*10;
			x += (*p-'0');
			p++;
			continue;
		}

		break;
	}while(1);

	return x;
}


HANDLE hfx = INVALID_HANDLE_VALUE;

void pin_debug()
{
	char buf[32768];
	DWORD rd = 0,wr;
	bool fg = true;
	int lp,lp2,lp3;
	int l,f;
	char *p;
	unsigned char d,c;
	DWORD ad = 0;
	unsigned char dat[32768];


	struct YM2608REG
	{
		YM2608REG()
		{
			ic = 1;
			wr = 1;
			cs = 0;
			a0 = 1;
			a1 = 0;
			d = 0;
		};

		unsigned char ic;
		unsigned char wr;
		unsigned char cs;
		unsigned char a0,a1;
		unsigned char d;

	} reg;


	//
	adpcm_load(0,NULL);
	unsigned char pcm_no = 1;


	do
	{
		printf(">");
		
		rd = 0;
		do
		{
			scanf("%c",&c);
			
			if (c == '\n')
			{
				buf[rd++] = '\0';
				break;
			}
			else
			{
				buf[rd++] = c;
			}

		}while(1);


		//sȂȂsȂ
		if (buf[0] == 0x0a || buf[0] == 0x0d || buf[0] == 0x00)
		{
			printf("\n");
			continue;
		}


		p = buf+1;
		while(*p)
		{
			if (*p == ' ' || *p == '\t')
			{
				p++;
				break;
			}
			if (*p == '\n')
			{
				p = NULL;
				break;
			}
			p++;
		}

		//̂珈悤ɂȂƂȂ
		//͐擪Ƀ_~[ċɂ悤ɂƂ

		d = 0;
		wr = 1;
		f = 0;
		while(p && *p)
		{
			switch(*p)
			{
			case 0x0a:
			case 0x0d:
				if (f & 1)
				{
					f = 0;
					dat[wr++] = d;
				}
				*p = '\0';
				p = NULL;
				break;
			case ' ':
			case '\t':
				if (f & 1)
				{
					f = 0;
					dat[wr++] = d;
					if (wr > 32767)	p = NULL;
				}
				break;
			case '0':	case '1':	case '2':	case '3':	case '4':
			case '5':	case '6':	case '7':	case '8':	case '9':
				if (f & 1)
				{
					d = (d << 4) | *p-'0';
					f = 0;
					dat[wr++] = d;
				}
				else
				{
					d = *p - '0';
					f = 1;
				}
				if (wr > 32767)	p = NULL;
				break;
			case 'a':	case 'b':	case 'c':	case 'd':	case 'e':	case 'f':
				if (f & 1)
				{
					d = (d << 4) | *p-'a' + 10;
					f = 0;
					dat[wr++] = d;
				}
				else
				{
					d = *p - 'a' + 10;
					f = 1;
				}
				if (wr > 32767)	p = NULL;
				break;
			case 'A':	case 'B':	case 'C':	case 'D':	case 'E':	case 'F':
				if (f & 1)
				{
					d = (d << 4) | *p-'A' + 10;
					f = 0;
					dat[wr++] = d;
				}
				else
				{
					d = *p - 'A' + 10;
					f = 1;
				}
				if (wr > 32767)	p = NULL;
				break;
			}
			if (p)	p++;
		}
		if (f & 1)
		{
			dat[wr++] = d;
		}


		rd = 0;
		switch(buf[0])
		{
		default:
			printf("invalid command [%c]\n",buf[0]);
			rd = 0;
			break;

		case 'q':	//I
			printf("exit!\n");
			fg = false;
			break;

		case 'c':	//connectR}h@op
			if ((hfx = CreateFile("COM3",
				GENERIC_READ | GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL)) == INVALID_HANDLE_VALUE)
			{
				if ((hfx = CreateFile("COM4",
					GENERIC_READ | GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL)) == INVALID_HANDLE_VALUE)
				{
					printf("connect error.\n");
					break;
				}
			}
			printf("connect..");

			//mF
			buf[0] = 16;
			WriteFile(hfx,buf,1,&wr,NULL);
			ReadFile(hfx,buf,4,&rd,NULL);
			if (buf[0] == '2' && buf[1] == '6' && buf[2] == '0' && buf[3] == '8')
			{
				printf("ok\nWelcome to YM2608!\nReady\n");
			}
			else
			{
				printf("err.\n");
			}
			break;


		case 'b':	//obNCgR}h	(Ȃ̂ŎƂ)
			if (hfx == INVALID_HANDLE_VALUE)
			{
				printf("no connect.\n");
				break;
			}
			buf[0] = 21;	//backlight command
			buf[1] = 0;		//0:toggle 1:on 2:off	<-0Ȃ
			WriteFile(hfx,buf,2,&wr,NULL);
			ReadFile(hfx,buf,1,&rd,NULL);
			switch(buf[0])
			{
			case 0:
				printf("backlight off\n");
				break;
			case 1:
				printf("backlight on\n");
				break;
			}
			break;


			//reset & rythm command
		case 'r':	//reset & rythm test
			if (hfx == INVALID_HANDLE_VALUE)
			{
				printf("no connect.\n");
				break;
			}

			if (buf[1] == 'y')
			{
				char *p = buf+2;
				do
				{
					if (*p == ' ' || *p == '\t')	break;
					p++;
				}while(*p);

				if (*p == '\0')
				{
					printf("??\n");
					break;
				}

				unsigned long x = get_numeric(p);

				//rythm test
				_write(0x11,0x3f);	//total level

				_write(0x18,0xdf);	//bass drum L+R,00,1000
				_write(0x19,0xdf);	//snea drum L+R,00,1000
				_write(0x1a,0xdf);	//topsimbal L+R,00,1000
				_write(0x1b,0xdf);	//hihat L+R,00,1000
				_write(0x1c,0xdf);	//tamtam L+R,00,1000
				_write(0x1d,0xdf);	//rim L+R,00,1000

				_write(0x10,x & 0x3f);	//dm:0,00,011111	0x20,0x10..
			}
			else
			{
				_reset();
			}
			break;


			//load sampling file
		case 'l':
			if (hfx == INVALID_HANDLE_VALUE)
			{
				printf("no connect.\n");
				break;
			}
			{
				char *p = buf+1;
				do
				{
					if (*p != ' ' && *p != '\t')	break;
					p++;
				}while(*p);
				if (*p == '\0')
				{
					printf("??\n");
					break;
				}

				//
				adpcm_load(pcm_no++,p);
			}
			break;

			//transfer sound data (driver & sound data)
		case 't':
			if (hfx == INVALID_HANDLE_VALUE)
			{
				printf("no connect.\n");
				break;
			}
			{
				char *p = buf+1;
				do
				{
					if (*p != ' ' && *p != '\t')	break;
					p++;
				}while(*p);
				if (*p == '\0')
				{
					printf("??\n");
					break;
				}

				HANDLE hf = CreateFile(
					p,
					GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,NULL);
				if (hf == INVALID_HANDLE_VALUE)
				{
					printf("file open error.\n");
					break;
				}

				DWORD sz,sz_org;
				sz = GetFileSize(hf,NULL) - 64;	//őTCY32k-64ɂƂ	32768ƃt@[G[f ŒĂ
				if (sz > 32*1024)	//max32k	trpschrn
				{
					sz = 32768-64;
				}
				char rbuf[32768];
				DWORD rd;
				ReadFile(hf,rbuf,32768-64,&rd,NULL);
				CloseHandle(hf);

				sz_org = sz;

				if (rd < 256)
				{
					printf("file read error.\n");
					break;
				}

				//t@C^Cv
				int file_type = 2;

				//]
				DWORD wr,wp = 0;
				bool b_err = false;
				unsigned char d = 0;
		
				do
				{
					//R}hM
					buf[0] = 0;
					WriteFile(hfx,buf,1,&wr,NULL);
					ReadFile(hfx,buf,1,&rd,NULL);
					if (buf[0] != 1)
					{
						printf("stop error.\n");
						b_err = true;
						break;
					}

					//݃|C^ZbgR}hM
					buf[0] = 1;
					WriteFile(hfx,buf,1,&wr,NULL);
					ReadFile(hfx,buf,1,&rd,NULL);
					if (buf[0] != 1)
					{
						printf("wp reset error.\n");
						b_err = true;
						break;
					}

					//
					while(sz)
					{
						if (sz < 60)
							wr = sz;
						else
							wr = 60;

						buf[0] = 2;
						memcpy(buf+1,rbuf+wp,wr);
						WriteFile(hfx,buf,wr+1,&wr,NULL);
						ReadFile(hfx,buf,1,&rd,NULL);
						if (buf[0] != 1)
						{
							printf("write error.\n");
							b_err = true;
							break;
						}

						sz -= wr-1;
						wp += wr-1;

						d = (d+1) & 31;
						if (!d || !sz)
						{
							unsigned long x = (sz_org-sz)*100/sz_org;
							printf("\r(%6d/%6d) %03d%% [",sz_org-sz,sz_org,x);
							int lp;
							for (lp = 1;lp < 11;lp++)
							{
								if (x >= lp*10)
									printf("o");
								else
									printf(".");
							}
							printf("]");
						}

					}

					printf("\n");

					break;
				}while(1);


				//tJn
				if (!b_err)
				{
					buf[0] = 3;
					buf[1] = file_type;	//0:trpschrn 1:bzh 2:other
					WriteFile(hfx,buf,2,&wr,NULL);
					ReadFile(hfx,buf,1,&rd,NULL);
					if (buf[0] != 1)
					{
						printf("start error.\n");
					}
				}
			}

			break;



			//play sampling index
		case 'p':
			if (hfx == INVALID_HANDLE_VALUE)
			{
				printf("no connect.\n");
				break;
			}
			{
				char *p = buf+1;
				do
				{
					if (*p != ' ' && *p != '\t')	break;
					p++;
				}while(*p);
				if (*p == '\0')
				{
					printf("??\n");
					break;
				}

				unsigned long x = get_numeric(p);

				adpcm_init(0x49cd,0xff,3);
				adpcm_play(x);
			}
			break;

			//direct register access
		case 'o':
			if (hfx == INVALID_HANDLE_VALUE)
			{
				printf("no connect.\n");
				break;
			}
			{
				char *p = buf+1;
				do
				{
					if (*p != ' ' && *p != '\t')	break;
					p++;
				}while(*p);
				if (*p == '\0')
				{
					printf("??\n");
					break;
				}

				unsigned long r,o;
				r = o = 0;
				do
				{
					if (*p == ' ' || *p == '\t')	break;

					r = r*16;
					if (*p >= '0' && *p <= '9')
						r += *p-'0';
					else if (*p >='A' && *p <= 'F')
						r += *p-'A'+10;
					else if (*p >='a' && *p <= 'f')
						r += *p-'a'+10;
					else
					{
						r = 0xffffffff;
						break;
					}

					p++;
				}while(*p);
				if (*p == '\0' || r > 0x1ff)
				{
					printf("??\n");
					break;
				}

				do
				{
					if (*p != ' ' && *p != '\t')	break;
					p++;
				}while(*p);
				if (*p == '\0')
				{
					printf("??\n");
					break;
				}

				do
				{
					if (*p == ' ' || *p == '\t')	break;

					o = o*16;
					if (*p >= '0' && *p <= '9')
						o += *p-'0';
					else if (*p >='A' && *p <= 'F')
						o += *p-'A'+10;
					else if (*p >='a' && *p <= 'f')
						o += *p-'a'+10;
					else
					{
						o = 0xffffffff;
						break;
					}

					p++;
				}while(*p);
				if (o > 0xff)
				{
					printf("??\n");
					break;
				}

				printf("r:%02x o:%02x\n",r,o);

				_write(r,o);
			}
			break;


		case 'n':	//̋Ȃ
			buf[0] = 24;	//next
			WriteFile(hfx,buf,1,&wr,NULL);
			break;

		}

	}while(fg);

	if (hfx != INVALID_HANDLE_VALUE)
	{
		CloseHandle(hfx);
	}


	return;
}







typedef struct PCMLIST
{
	PCMLIST(){
		fg = 0;
		ad = 0;
		sz = 0;
	};
	unsigned char fg;
	unsigned long ad;
	unsigned short sz;
};
unsigned char m_pcmindex;
PCMLIST m_adpcmlist[128];
unsigned long m_adpt;
unsigned char m_adpcm_key;

void adpcm_init(unsigned short sampling_rate,unsigned char total_level,unsigned char pan)
{
	//reset
	_write2(0x00, 0x20);	//mem
	_write2(0x00, 0x21);	//resetȂSPOFFȂ

	_write2(0x09, sampling_rate & 0xff);	//samplingrate L
	_write2(0x0a, (sampling_rate >> 8) & 0xff);	//H

	_write2(0x0b, total_level);	//total level
	switch(pan)
	{
	default:
	case 3:
		_write2(0x01, 0xc2);	//L+R 8bitmem
		break;
	case 1:
		_write2(0x01, 0x82);	//L 8bitmem
		break;
	case 2:
		_write2(0x01, 0x42);	//R 8bitmem
		break;
	}

}

void adpcm_play(unsigned char idx)
{

	if (!m_adpcmlist[idx].fg)	return;

	//ĐꍇAxZbgȂƂȂ߁AⓚpŃZbg
	_write2(0x00, 0x21);	//reset

	//ĐAhXƒ~AhXݒ肷
	_write2(0x02, m_adpcmlist[idx].ad & 0xff);			//startL
	_write2(0x03, (m_adpcmlist[idx].ad >> 8) & 0xff);	//startH
	unsigned long stopad = m_adpcmlist[idx].ad + m_adpcmlist[idx].sz -1;
	_write2(0x04, stopad & 0xff);					//stopL
	_write2(0x05, (stopad >> 8) & 0xff);				//stopH

	//Đ
	_write2(0x00, 0xa0);	//start + mem

	return;
}

void adpcm_load(unsigned char idx,const char *filename)
{
	//wȂNA
	if (!idx && !filename)
	{
		m_adpt = 0;
		m_pcmindex = 0;
		return;
	}
	
	//wt@C[h
	int r = 0;
	FILE *fr = fopen(filename,"rb");
	if (!fr)
	{
		fprintf(stderr,"file read error.\n");
		return;
	}
	char rbuf[262144];
	unsigned int sz = fread(rbuf,1,262144,fr);
	fclose(fr);
	if (!sz)
	{
		fprintf(stderr,"read error.\n");
		return;
	}

	printf("[%s] -> [%d,%d]\n",filename,m_adpt,sz);
	unsigned int sz_org = sz;
	unsigned char d = 0;

	//f[^]
	if (hfx != INVALID_HANDLE_VALUE)
	{
		DWORD wr,rd;

		unsigned int z = 0;
		unsigned int rrd = 0,ad = 0,divide = 8192,wad = m_adpt;
		bool bw = false;
		char buf[64];
		do
		{
			//512Pʂ̐lŁALbV[U
			//܂鏈
			if (divide > 60)
			{
				if (sz > 60)
					z = 60;
				else
				{
					z = sz;
					bw = true;
				}
			}
			else
			{
				if (divide > sz)
					z = sz;
				else
					z = divide;
				bw = true;
			}

			//pic32mx270f256d̃LbVɓ
			buf[0] = 9;
			buf[1] = (unsigned char)z;	//oCg
			buf[2] = (unsigned char)(ad & 0xff);
			buf[3] = (unsigned char)((ad >> 8) & 0xff);
			memcpy(buf+4,rbuf+rrd,z);
			WriteFile(hfx,buf,4+z,&wr,NULL);
			ReadFile(hfx,buf,1,&rd,NULL);
			if (buf[0] != 1)
			{
				fprintf(stderr,"cache write error.\n");
				break;
			}

			//ym2608Oɏ
			if (bw)
			{
				unsigned short wsize = 8192 - divide + z;
				if (wsize & 511)	//0x1ff
				{
					wsize = (wsize & 0xfe00) + 512;
				}

				buf[0] = 10;
				buf[1] = (unsigned char)(wsize & 0xff);
				buf[2] = (unsigned char)((wsize >> 8) & 0xff);
				buf[3] = (unsigned char)(wad & 0xff);
				buf[4] = (unsigned char)((wad >> 8) & 0xff);
				WriteFile(hfx,buf,5,&wr,NULL);
				ReadFile(hfx,buf,1,&rd,NULL);
				if (buf[0] != 1)
				{
					fprintf(stderr,"ym2608 write error.\n");
					break;
				}

				bw = false;
				divide = 8192;
				wad += (wsize >> 5);
				ad = 0;
			}
			else
			{
				divide -= z;
				ad += z;
			}

			rrd += z;
			sz -= z;

			d ^= 1;
			if (d || !sz)
			{
				unsigned long x = (sz_org-sz)*100/sz_org;
				printf("\r(%6d/%6d) %03d%% [",sz_org-sz,sz_org,x);
				int lp;
				for (lp = 1;lp < 11;lp++)
				{
					if (x >= lp*10)
						printf("o");
					else
						printf(".");
				}
				printf("]");
			}


		}while(sz);

		printf("\n");

		r = 1;

		//Xgɓo^	adpcm8rbgڑ̏ꍇ́A32oCgPʂɂȂ
		//w肵zɓ
		m_adpcmlist[idx].ad = m_adpt;
		m_adpcmlist[idx].sz = ((rrd & 0x1f) != 0 ? (rrd & 0xffe0)+32 : rrd & 0xffe0) >> 5;
		m_adpcmlist[idx].fg = 1;
		m_adpt += m_adpcmlist[idx].sz;

		printf("idx:%d:[%d,%d]\n",idx,m_adpcmlist[idx].ad,m_adpcmlist[idx].sz);
	}
	else
	{
		fprintf(stderr,"com port open error.\n");
	}

	return;
}



void _write(unsigned char addr,unsigned char data)
{
	DWORD wr = 0;
	unsigned char buf[64];

	buf[0] = 19;
	buf[1] = addr;
	buf[2] = data;
	WriteFile(hfx,buf,3,&wr,NULL);
}

void _write2(unsigned char addr,unsigned char data)
{
	DWORD wr = 0;
	unsigned char buf[64];

	buf[0] = 20;
	buf[1] = addr;
	buf[2] = data;
	WriteFile(hfx,buf,3,&wr,NULL);
}


void _reset()
{
	DWORD wr,rd;
	unsigned char buf[64];

	buf[0] = 0;
	WriteFile(hfx,buf,1,&wr,NULL);
	ReadFile(hfx,buf,1,&rd,NULL);
	printf("reset\n");
}
